﻿	function Errorhandling(error, file, row)
    {
      alert("Error: " + error + "\nFile: " + file + "\nRow: " + row);
    }
	
	var order = 6;
	var datapoints = 200;
    var a = new Array(order);   // matrix for Gauss
    var x = new Array(order);   // x-vector for Gauss
    var y = new Array(order);   // y-vector for Gauss
	var y_k = new Array(order); // supporting points y
    var x_k = new Array(order); // supporting points x
	var yp = new Array(datapoints); // inerpolated curve y
    var xp = new Array(datapoints); // inerpolated curve x
	var actKnot; 
	var knotName;

    function calculate()
    {
		var i
		var k;
		for(i=0; i < order; i++)
		{
			a[i] = new Array(order);
			y_k[i] = document.getElementById("Y" + (i+1)).value;
			x_k[i] = document.getElementById("X" + (i+1)).value;
		}
		for (i = 0; i < order; i++)
        {
            y[i] = y_k[order - 1 - i]; 
			x[i] = 0;
            for (k = 0; k < order; k++)
            {
				a[i][k] = Math.pow(x_k[order - 1 - i], k);
            }   
        }
		
		try
		{
			if(eliminate())
			{
				solve()
				for(var i=0; i < order; i++)
				{
					document.getElementById("P" + (i+1)).value = x[i].toFixed(3);  
				}
				interpolate(datapoints, x_k[0], x_k[order - 1]);
				drawGraph(datapoints, x_k[0], x_k[order - 1]);
			}
			else
				alert("Calculation error in elimination!");
		}
		catch(er)
		{
			alert(er);
		}
	}

   function switchRows(n)
   {
     var tempD;
     var i, j;
     for (i = n; i <= order - 2; i++)
     {
       tempD = a[i];
       a[i] = a[i + 1]
       a[i + 1] = tempD
       tempD = y[i];
       y[i] = y[i + 1];
       y[i + 1] = tempD;
     }
   }


   function eliminate()
   {
      var i, k, l;
      var calcError = false;

      for (k = 0; k < order - 1; k++)
      {
        l = k + 1;
        while ((Math.abs(a[k][k]) < 1e-8) && (l < order))
        {
           switchRows(k);
           l++;
        }
        if (l < order)
        {
          for (i = k; i <= order - 2; i++)
          {
            if (!calcError)
            {
              if (Math.abs(a[i + 1][k]) > 1e-8)
              {
                for (l = k + 1; l <= order - 1; l++)
                {
                  a[i + 1][l] = a[i + 1][l] * a[k][k] - a[k][l] * a[i + 1][k];
                }
                y[i + 1] = y[i + 1] * a[k][k] - y[k] * a[i + 1][k];
                a[i + 1][k] = 0;
              }
            }
          }
        }
        else
          calcError = true;
      }
      return !calcError;
    }


    function solve()
    {
      var k, l;
      for (k = order - 1; k >= 0; k--)
      {
        for (l = order - 1; l >= k; l--)
        {
           y[k] = y[k] - x[l] * a[k][l];
        }
        if(Math.abs(a[k][k]) > 1e-8)
          x[k] = y[k] / a[k][k];
        else
          throw "Calculation eror: Division by cero";
      }
    }

	function interpolate(maxPoints, minTime, maxTime)
    {
        var i, k;
        for (i = 0; i < maxPoints; i++)
        {
            yp[i] = 0;
            xp[i] = (i+1) * maxTime / maxPoints;
            for (k = 0; k < order; k++)
            {   
                yp[i] = yp[i] + x[k] * Math.pow( xp[i], k);
            }
        }
    }


    function createMatrix(order, knot)
    {
		knotName = knot;
		actKnot = document.getElementById(knot);
		var  tableRow = document.createElement("p");
		actKnot.appendChild(tableRow);
		var text = document.createTextNode(" y : ");
	    tableRow.appendChild(text);
		for (var i = 1; i <= order; i++)
		{
			var res = document.createElement("input");
			res.setAttribute("id","Y" + i);
			res.setAttribute("style","width:60px");
			tableRow.appendChild(res);
		}
		var  tableRow = document.createElement("p");
		actKnot.appendChild(tableRow);
		var text = document.createTextNode(" x : ");
	    tableRow.appendChild(text);
		for (var i = 1; i <= order; i++)
		{
			var res = document.createElement("input");
			res.setAttribute("id","X" + i);
			res.setAttribute("style","width:60px");
			tableRow.appendChild(res);
		}
		var  tableRow = document.createElement("p");
		actKnot.appendChild(tableRow);
		var text = document.createTextNode(" p : ");
	    tableRow.appendChild(text);
		for (var i = 1; i <= order; i++)
		{
			var res = document.createElement("input");
			res.setAttribute("id","P" + i);
			res.setAttribute("style","width:60px");
			tableRow.appendChild(res);
		}
	}
	
	function drawGraph(maxPoints, minX, maxX)
	{
		var i,j;
        var maxVal = -1.0;
        var minVal = 1.0;
        var scalefactor;
		var xRange;
        var drawCeroline;
		var graphHeight;
		var graphWidth;
		var p1X, p1Y;
		var p2X, p2Y;
		let cx = document.querySelector("canvas").getContext("2d");
		cx.beginPath();
		graphHeight = cx.canvas.height;
		graphWidth = cx.canvas.width;
		cx.clearRect(0, 0, graphWidth, graphHeight);
		for (j = 0; j < maxPoints - 1; j++)
        {
            if ((xp[j] >= minX) && (xp[j] <= maxX))
            {
                if (maxVal < yp[j])
                    maxVal = yp[j];
                if (minVal > yp[j])
                    minVal = yp[j];
            }
        }
		xRange = (maxX - minX) * 1.05 ;
		if (minVal < 0)
        {
            if (maxVal > 0)
            {
                if (maxVal > Math.abs(minVal))
                    scalefactor = graphHeight / maxVal / 2.2;
                else
                    scalefactor = graphHeight / Math.absbs(minVal) / 2.2;
            }
            else
                scalefactor = 5.0;
            drawCeroline = true;
        }
        else
        {
            scalefactor = graphHeight / (maxVal) / 1.1;
            drawCeroline = false;
        }
		if (drawCeroline)
        {
			cx.beginPath();
			cx.moveTo(0, graphHeight / 2);
			cx.lineTo(graphWidth, graphHeight / 2);
			cx.strokeStyle='black';
			cx.stroke();
        }
		
		if (maxX > 0) // draw interpolated graph
        {
			cx.beginPath();
            for (j = 0; j < maxPoints - 1; j++)
            {
                if ((xp[j] >= minX) && (xp[j] <= maxX))
                {
                    p1X = (xp[j] - minX) * graphWidth / xRange + 20;
                    p2X = (xp[j + 1] - minX) * graphWidth / xRange + 20;
                    if (drawCeroline)
                    {
                        p1Y = (graphHeight / 2) - yp[j] * scalefactor;
                        p2Y = (graphHeight / 2) - yp[j + 1] * scalefactor;
                    }
                    else
                    {
                        p1Y = (graphHeight) - yp[j] * scalefactor;
                        p2Y = (graphHeight) - yp[j + 1] * scalefactor;
                    }
                    cx.moveTo(Math.round(p1X), Math.round(p1Y));
					cx.lineTo(Math.round(p2X), Math.round(p2Y));
                }
            }
			cx.strokeStyle='blue';
			cx.stroke();
        }
		
		cx.beginPath();
		for (j = 0; j < order; j++) // mark reference points
        {
            p1X = (x_k[j]- minX) * graphWidth / xRange + 20;
            if (drawCeroline)
                p1Y = graphHeight / 2 - y_k[j] * scalefactor;
            else
                p1Y = graphHeight - y_k[j] * scalefactor;
			cx.rect(Math.round(p1X-2), Math.round(p1Y) -2, 4,4);
			cx.fill();
        }		
		cx.strokeStyle='red';
		cx.stroke();
	}
 
	function selectOrder()
	{
		const input = document.getElementById('idOrder');
		order = input.value;
		a = new Array(order);
        x = new Array(order);
        y = new Array(order);
		y_k = new Array(order);
		x_k = new Array(order);
		for(var i = actKnot.childNodes.length - 1; i >= 0; i--)
		{
		   var el = actKnot.childNodes[i];
		   actKnot.removeChild(el);
		}
		createMatrix(order, knotName);
	}